import { Ref } from "vue";
import type { CreateRuntime, StateType, BaseShape } from "@leanjs/core";
import type { StatePropArgs } from "./types";
export declare const createRuntimeBindings: <MyCreateRuntime extends CreateRuntime<import("@leanjs/core").Runtime<BaseShape, import("@leanjs/core").Key, import("@leanjs/core").BaseApiFactory<BaseShape, import("@leanjs/core").Key>, import("@leanjs/core").Key>> = CreateRuntime<import("@leanjs/core").Runtime<BaseShape, import("@leanjs/core").Key, import("@leanjs/core").BaseApiFactory<BaseShape, import("@leanjs/core").Key>, import("@leanjs/core").Key>>, MyRuntime extends ReturnType<MyCreateRuntime> = ReturnType<MyCreateRuntime>, State extends StateType<MyRuntime> = StateType<MyRuntime>>(_createRuntime: MyCreateRuntime) => {
    useSharedState: <Prop extends Exclude<keyof State, number> = Exclude<keyof State, number>>(...props: Prop[] | StatePropArgs<State, Prop>[]) => { [P in Prop]: Ref<State[P]>; };
    HostProvider: {
        new (...args: any[]): {
            $: import("vue").ComponentInternalInstance;
            $data: {};
            $props: Partial<{}> & Omit<Readonly<import("vue").ExtractPropTypes<{
                origin: {
                    type: import("vue").PropType<string>;
                    required: true;
                };
                runtime: {
                    type: import("vue").PropType<import("@leanjs/core").Runtime<BaseShape, import("@leanjs/core").Key, import("@leanjs/core").BaseApiFactory<BaseShape, import("@leanjs/core").Key>, import("@leanjs/core").Key>>;
                    required: true;
                };
            }>> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, never>;
            $attrs: {
                [x: string]: unknown;
            };
            $refs: {
                [x: string]: unknown;
            };
            $slots: Readonly<{
                [name: string]: import("vue").Slot | undefined;
            }>;
            $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
            $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
            $emit: (event: string, ...args: any[]) => void;
            $el: any;
            $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
                origin: {
                    type: import("vue").PropType<string>;
                    required: true;
                };
                runtime: {
                    type: import("vue").PropType<import("@leanjs/core").Runtime<BaseShape, import("@leanjs/core").Key, import("@leanjs/core").BaseApiFactory<BaseShape, import("@leanjs/core").Key>, import("@leanjs/core").Key>>;
                    required: true;
                };
            }>>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {}, {}, string> & {
                beforeCreate?: ((() => void) | (() => void)[]) | undefined;
                created?: ((() => void) | (() => void)[]) | undefined;
                beforeMount?: ((() => void) | (() => void)[]) | undefined;
                mounted?: ((() => void) | (() => void)[]) | undefined;
                beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
                updated?: ((() => void) | (() => void)[]) | undefined;
                activated?: ((() => void) | (() => void)[]) | undefined;
                deactivated?: ((() => void) | (() => void)[]) | undefined;
                beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
                beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
                destroyed?: ((() => void) | (() => void)[]) | undefined;
                unmounted?: ((() => void) | (() => void)[]) | undefined;
                renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
                renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
                errorCaptured?: (((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void)[]) | undefined;
            };
            $forceUpdate: () => void;
            $nextTick: typeof import("vue").nextTick;
            $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean> | undefined): import("vue").WatchStopHandle;
        } & Readonly<import("vue").ExtractPropTypes<{
            origin: {
                type: import("vue").PropType<string>;
                required: true;
            };
            runtime: {
                type: import("vue").PropType<import("@leanjs/core").Runtime<BaseShape, import("@leanjs/core").Key, import("@leanjs/core").BaseApiFactory<BaseShape, import("@leanjs/core").Key>, import("@leanjs/core").Key>>;
                required: true;
            };
        }>> & import("vue").ShallowUnwrapRef<{}> & {} & import("vue").ComponentCustomProperties & {};
        __isFragment?: undefined;
        __isTeleport?: undefined;
        __isSuspense?: undefined;
    } & import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
        origin: {
            type: import("vue").PropType<string>;
            required: true;
        };
        runtime: {
            type: import("vue").PropType<import("@leanjs/core").Runtime<BaseShape, import("@leanjs/core").Key, import("@leanjs/core").BaseApiFactory<BaseShape, import("@leanjs/core").Key>, import("@leanjs/core").Key>>;
            required: true;
        };
    }>>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, {}, {}, string> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & (new () => {
        $slots: {
            default: (_: {}) => any;
        };
    });
};
export declare const isPropObj: <State extends BaseShape, Prop extends Exclude<keyof State, number>>(prop: any) => prop is StatePropArgs<State, Prop>;
